#include <OLED_I2C.h>
OLED  myOLED(SDA, SCL, 8);
extern uint8_t SmallFont[];
extern uint8_t MegaNumbers[];

byte n = 8;      // число секторов

float rev_time;
volatile unsigned long lastflash, flash, lastshow;
unsigned int RPM;
String spaces = "       ";

void setup() {
  myOLED.begin();
  myOLED.setFont(SmallFont);
  attachInterrupt(0, sens, RISING);    // подключить прерывание на 2 пин при повышении сигнала
  pinMode(3, OUTPUT);                  // 3 пин как выход
  digitalWrite(3, HIGH);               // подать 5 вольт на 3 пин
}

void sens() {
  flash = micros() - lastflash;   // вычислить время между двумя оборотами
  lastflash = micros();           // запомнить время последнего оборота
}

void loop() {
  if (micros() - lastflash > 1000000) { // если сигнала нет больше секунды
    RPM = 0;                            // считаем, что всё стоит и не крутится
  } else {
    rev_time = (float) flash / 1000000 * n;             // время одного оборота в секундах, с учётом числа лопастей
    RPM = (float) 60 / rev_time;                        // обороты в минуту
  }
  if (millis() - lastshow > 300) {  // кадждые 300 миллисекунд
  myOLED.clrScr();
  myOLED.setFont(MegaNumbers);
  myOLED.printNumI(RPM, 5, 5);
  myOLED.update();
delay(300);

  }
}
